
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, 2012 and Azure
-- --------------------------------------------------
-- Date Created: 05/09/2014 15:16:29
-- Generated from EDMX file: C:\Projects\Csharp Special Topics\FeedReader\GUI\Database.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [Database];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_FeedFeedItem]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[FeedItemSet] DROP CONSTRAINT [FK_FeedFeedItem];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FeedSet]', 'U') IS NOT NULL
    DROP TABLE [dbo].[FeedSet];
GO
IF OBJECT_ID(N'[dbo].[FeedItemSet]', 'U') IS NOT NULL
    DROP TABLE [dbo].[FeedItemSet];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'FeedSet'
CREATE TABLE [dbo].[FeedSet] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [Title] nvarchar(max)  NOT NULL,
    [URL] nvarchar(max)  NOT NULL,
    [Description] nvarchar(max)  NULL,
    [Image] nvarchar(max)  NULL,
    [Favicon] nvarchar(max)  NULL
);
GO

-- Creating table 'FeedItemSet'
CREATE TABLE [dbo].[FeedItemSet] (
    [Id] int IDENTITY(1,1) NOT NULL,
    [OriginalID] nvarchar(max)  NOT NULL,
    [Title] nvarchar(max)  NOT NULL,
    [Summary] nvarchar(max)  NOT NULL,
    [PublishDate] datetime  NOT NULL,
    [FeedId] int  NOT NULL,
    [Read] bit  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [Id] in table 'FeedSet'
ALTER TABLE [dbo].[FeedSet]
ADD CONSTRAINT [PK_FeedSet]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- Creating primary key on [Id] in table 'FeedItemSet'
ALTER TABLE [dbo].[FeedItemSet]
ADD CONSTRAINT [PK_FeedItemSet]
    PRIMARY KEY CLUSTERED ([Id] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [FeedId] in table 'FeedItemSet'
ALTER TABLE [dbo].[FeedItemSet]
ADD CONSTRAINT [FK_FeedFeedItem]
    FOREIGN KEY ([FeedId])
    REFERENCES [dbo].[FeedSet]
        ([Id])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_FeedFeedItem'
CREATE INDEX [IX_FK_FeedFeedItem]
ON [dbo].[FeedItemSet]
    ([FeedId]);
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------