﻿using HtmlAgilityPack;
using System;
using System.Linq;
using System.Net;

namespace GUI
{
    class FaviconParser
    {

        // append favicon.ico to url
        private static String UrlGuess(String url)
        {
            String result = null;

            try
            {
                using (WebClient client = new WebClient())
                {
                    result = Convert.ToBase64String(client.DownloadData(url + "/favicon.ico"));
                }
            }
            catch (Exception) { }

            return result;
        }

        // <link rel="shortcut icon" href="http://o.aolcdn.com/os/autoblog/favicon.ico"/>
        private static String RelShortcutIcon(String url)
        {
            String result = null;

            try
            {
                HtmlWeb web = new HtmlWeb();
                HtmlDocument doc = web.Load(url);

                String link = (from el in doc.DocumentNode.Descendants()
                               where el.Name == "link"
                               && el.Attributes["rel"] != null
                               && el.Attributes["rel"].Value == "shortcut icon"
                               && el.Attributes["href"] != null
                               select el.Attributes["href"].Value).FirstOrDefault();
                if (!link.StartsWith("http"))
                {
                    link = "http:" + link;
                }
                using (WebClient client = new WebClient())
                {
                    result = Convert.ToBase64String(client.DownloadData(link));
                }
            }
            catch (Exception) { }

            return result;
        }

        // <link rel="icon" href="/favicon.png" />
        private static String RelIcon(String url)
        {
            String result = null;

            try
            {
                HtmlWeb web = new HtmlWeb();
                HtmlDocument doc = web.Load(url);

                String link = (from el in doc.DocumentNode.Descendants()
                               where el.Name == "link"
                               && el.Attributes["rel"] != null
                               && el.Attributes["rel"].Value == "icon"
                               && el.Attributes["href"] != null
                               select el.Attributes["href"].Value).FirstOrDefault();
                if (!link.StartsWith("http"))
                {
                    link = "http:" + link;
                }
                using (WebClient client = new WebClient())
                {
                    result = Convert.ToBase64String(client.DownloadData(link));
                }
            }
            catch (Exception) { }

            return result;
        }

        public static String Load(String url)
        {
            if (String.IsNullOrEmpty(url))
                return null;

            String ret = RelShortcutIcon(url);
            if (String.IsNullOrEmpty(ret))
                ret = RelIcon(url);
            if (String.IsNullOrEmpty(ret))
                ret = UrlGuess(url);

            return ret;
        }
    }
}
