﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GUI
{
    public partial class Feed : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public void NotifyPropertChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        private Boolean _Updating;
        public Boolean Updating
        {
            get
            {
                return _Updating;
            }
            set
            {
                _Updating = value;
                NotifyPropertChanged("Updating");
            }
        }

        private int _Unread;
        public int Unread
        {
            get
            {
                return FeedItem.Count(x => x.Read == false);
            }
            set
            {
                _Unread = value;
                NotifyPropertChanged("Unread");
            }
        }

    }
}
